#*
# *  plog // a blog cms system written in perl using xml for contents
# ****************************************************************************
# *  This source is covered by the GNU GPL http://www.gnu.org
# *  (c) 2003 - 2005 www.strg.at
# *  Software distributed under the License is distributed on an "AS IS"
# *  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# *  License for a specific language governing rights and limitations under
# *  the License.
# *
# *  The Initial Developer is: Juergen Schmidt <juergen@strg.at>
# ****************************************************************************/

#/**
# * DESCRIPTION: the plog perl module
# * @package  plog
# * @author   juergen schmidt <juergen@strg.at>
# * @since    Version 0.1
# * @version  0.1
# * @license  http://gnu.org
# */

use strict;

{
  package modules::plog;


  #/**
  # * plog::new()
  # * // purpose: constructor
  # * @return reference
  # */
  sub new   {
    my $recref = {};		            # Creates reference to object
    bless $recref;                  # Associates reference with class
    $recref -> initialize(@_);      # Call local initialize subroutine
    return $recref;                 # Explicit return of value of $recref
  } #sub


  #/**
  # * plog::initialize()
  # * // purpose: initialization of plog object
  # * @return NULL
  # */
  sub initialize {
	  print "\n\n " . $config::system . " " . $config::version . " running on " .  
		                $config::host . " written by " .  $config::author . " under GPL \n";
    # nothing to do yet
  }


  #/**
  # * plog::createArgv()
  # * // purpose: read and create arguments and set as object-attributes
  # * @return NULL
  # */
	sub createArgv {
    (my $action, my $page, my $count) = split(/\//, $_[1], 3);
    my %argv = ("action", $action, "page", $page, "count", $count);
	  return %argv;
	} # sub

	
  #/**
  # * plog::parseData()
  # * // purpose: initialization of plog object
  # * @return NULL
  # */
	sub parseData  {
    my $data = $_[1];
    $data =~ s/\[b\](.*?)\[\/b\]/<stong>$1<\/strong>/gsi;
		$data =~ s/\[pre\](.*?)\[\/pre\]/<pre>$1<\/pre>/gsi;
    $data =~ s/\[i\](.*?)\[\/i\]/<em>$1<\/em>/gsi;
		$data =~ s/\[inturl=(.*?)\](.*?)\[\/url\]/<a href="$1" title="internal link: $1">$2<\/a>/gsi;
		$data =~ s/\[email\](.*?)\[\/email\]/<a href="mailto:$1">$1<\/a>/gsi;
		$data =~ s/\[h1\](.*?)\[\/h1\]/<h1>$1<\/h1>/gsi;
		$data =~ s/\[h2\](.*?)\[\/h2\]/<h2>$1<\/h2>/gsi;
		$data =~ s/\[h3\](.*?)\[\/h3\]/<h3>$1<\/h3>/gsi;
		$data =~ s/\[h4\](.*?)\[\/h4\]/<h4>$1<\/h4>/gsi;
		$data =~ s/\[h5\](.*?)\[\/h5\]/<h5>$1<\/h5>/gsi;
		$data =~ s/\[h6\](.*?)\[\/h6\]/<h6>$1<\/h6>/gsi;
		$data =~ s/\[h7\](.*?)\[\/h7\]/<h7>$1<\/h7>/gsi;
		$data =~ s/\[li\](.*?)\[\/li\]/<li>$1<\/li>/gsi;
		$data =~ s/\[ul\](.*?)\[\/ul\]/<\/p><ul>$1<\/ul><p>/gsi;
		$data =~ s/\[abbr=(.*?)\](.*?)\[\/abbr\]/<abbr title="$1">$2<\/abbr>/gsi;
		$data =~ s/\[br\]/<br >/gsi;
    $data =~ s/\[url=(.*?)\](.*?)\[\/url\]/<a href="$1" title="external link: $1">$2<\/a>/gsi;
    return $data;
	} #sub


  #/**
  # * plog::createPage()
  # * // purpose: initialization of plog object
  # * @return NULL
  # */
	sub createPage {
		my $path = $config::path . $_[1];
		open (HTMLFILE, "> $path");
		print HTMLFILE $_[2];
		close(HTMLFILE);
		print "\n created " . $path . " [done]";
    return;
	} # sub


}
1;
